//
//  CustomView.m
//
//  Code generated using QuartzCode on 7/11/14.
//  www.quartzcodeapp.com
//

#import "CustomView.h"
#import "QCMethod.h"

@interface CustomView ()

@property (nonatomic, strong) NSArray*  layerWithAnims;
@property (nonatomic, assign) BOOL animationAdded;

@property (nonatomic, strong) CALayer *flower;

@end

@implementation CustomView

- (instancetype)initWithFrame:(CGRect)frame
{
	self = [super initWithFrame:frame];
	if (self) {
		[self setupLayers];
	}
	return self;
}

- (instancetype)initWithCoder:(NSCoder *)coder
{
	self = [super initWithCoder:coder];
	if (self) {
		[self setupLayers];
	}
	return self;
}


- (void)setupLayers{
	CALayer * flower = [CALayer layer];
	flower.anchorPoint             = CGPointMake(0.5, 0);
	flower.frame                   = CGRectMake(59, 0, 257, 168);
	flower.contents                = (id)[UIImage imageNamed:@"flower.jpg"].CGImage;
	
	CAShapeLayer*  flowerMask     = [CAShapeLayer layer];
	flowerMask.frame              = CGRectMake(0, 0, 111, 111);
	UIBezierPath*  flowerMaskPath = [UIBezierPath bezierPathWithOvalInRect:flowerMask.bounds];
	flowerMask.position           = CGPointMake(CGRectGetMidX(flower.bounds), CGRectGetMidY(flower.bounds));
	flowerMask.path               = flowerMaskPath.CGPath;
	flower.mask                   = flowerMask;
	[self.layer addSublayer:flower];
	_flower = flower;
	
	self.layerWithAnims = @[flower];
}


- (IBAction)startAllAnimations:(id)sender{
	self.animationAdded = NO;
	for (CALayer *layer in self.layerWithAnims){
		layer.speed = 1;
	}
	[self.flower addAnimation:[self flowerAnimation] forKey:@"flowerAnimation"];
	[self.flower.mask addAnimation:[self flowerMaskAnimation] forKey:@"flowerMaskAnimation"];
}

- (void)setProgress:(CGFloat)progress{
	if(!self.animationAdded){
		[self startAllAnimations:nil];
		self.animationAdded = YES;
		for (CALayer *layer in self.layerWithAnims){
			layer.speed = 0;
			layer.timeOffset = 0;
		}
	}
	else{
		CGFloat totalDuration = 0.78;
		CGFloat offset = progress * totalDuration;
		for (CALayer *layer in self.layerWithAnims){
			layer.timeOffset = offset;
		}
	}
}

- (CABasicAnimation*)flowerAnimation{
	CABasicAnimation * transformAnim = [CABasicAnimation animationWithKeyPath:@"transform"];
	transformAnim.toValue            = [NSValue valueWithCATransform3D:CATransform3DMakeScale(1.8, 1.8, 1)];;
	transformAnim.duration           = 0.783;
	transformAnim.timingFunction     = [CAMediaTimingFunction functionWithControlPoints:0.42 :0 :0.636 :1.65];
	transformAnim.fillMode = kCAFillModeBoth;
	transformAnim.removedOnCompletion = NO;
	
	return transformAnim;
}



- (CABasicAnimation*)flowerMaskAnimation{
	CABasicAnimation * transformAnim = [CABasicAnimation animationWithKeyPath:@"transform"];
	transformAnim.toValue            = [NSValue valueWithCATransform3D:CATransform3DMakeScale(3, 2.4, 1)];;
	transformAnim.duration           = 0.783;
	transformAnim.timingFunction     = [CAMediaTimingFunction functionWithName:kCAMediaTimingFunctionEaseInEaseOut];
	transformAnim.fillMode = kCAFillModeBoth;
	transformAnim.removedOnCompletion = NO;
	
	return transformAnim;
}

@end