//
//  CustomView.swift
//
//  Code generated using QuartzCode on 7/11/14.
//  www.quartzcodeapp.com
//

import UIKit

class CustomView: UIView {
	
	var layerWithAnims : [CALayer]!
	var animationAdded : Bool = false
	var flower : CALayer!
	
	override init(frame: CGRect) {
		super.init(frame: frame)
		setupLayers()
	}
	
	required init(coder aDecoder: NSCoder)
	{
		super.init(coder: aDecoder)
		setupLayers()
	}
	
	func setupLayers(){
		flower = CALayer()
		flower.anchorPoint   = CGPointMake(0.5, 0)
		flower.frame         = CGRectMake(59, 0, 257, 168)
		flower.contents      = UIImage(named:"flower.jpg")?.CGImage
		
		var flowerMask      = CAShapeLayer()
		flowerMask.frame    = CGRectMake(0, 0, 111, 111)
		var flowerMaskPath  = UIBezierPath(ovalInRect: flowerMask.bounds)
		flowerMask.position = CGPointMake(flower.bounds.midX, flower.bounds.midY)
		flowerMask.path     = flowerMaskPath.CGPath
		flower.mask         = flowerMask
		self.layer.addSublayer(flower)
		
		self.layerWithAnims = [flower]
	}
	
	
	@IBAction func startAllAnimations(sender: AnyObject!){
		self.animationAdded = false
		for layer in self.layerWithAnims{
			layer.speed = 1
		}
		flower?.addAnimation(flowerAnimation(), forKey:"flowerAnimation")
		flower.mask.addAnimation(flowerMaskAnimation(), forKey:"flowerAnimation")
	}
	
	var progress: CGFloat = 0 {
		didSet{
			if(!self.animationAdded){
				startAllAnimations(nil)
				self.animationAdded = true
				for layer in self.layerWithAnims{
					layer.speed = 0
					layer.timeOffset = 0
				}
			}
			else{
				var totalDuration : CGFloat = 0.78
				var offset = progress * totalDuration
				for layer in self.layerWithAnims{
					layer.timeOffset = CFTimeInterval(offset)
				}
			}
		}
	}
	
	func flowerAnimation() -> CABasicAnimation{
		var transformAnim            = CABasicAnimation(keyPath:"transform")
		transformAnim.toValue        = NSValue(CATransform3D: CATransform3DMakeScale(1.8, 1.8, 1));
		transformAnim.duration       = 0.783
		transformAnim.timingFunction = CAMediaTimingFunction(controlPoints: 0.42, 0, 0.636, 1.65)
		transformAnim.fillMode = kCAFillModeBoth
		transformAnim.removedOnCompletion = false
		
		return transformAnim;
	}
	
	
	
	func flowerMaskAnimation() -> CABasicAnimation{
		var transformAnim            = CABasicAnimation(keyPath:"transform")
		transformAnim.toValue        = NSValue(CATransform3D: CATransform3DMakeScale(3, 2.4, 1));
		transformAnim.duration       = 0.783
		transformAnim.timingFunction = CAMediaTimingFunction(name:kCAMediaTimingFunctionEaseInEaseOut)
		transformAnim.fillMode = kCAFillModeBoth
		transformAnim.removedOnCompletion = false
		
		return transformAnim;
	}

}